#!/bin/perl

################################################################################
#
# checkPidFiles.pl
#
################################################################################
#
# Checks pid files
#
################################################################################
# 
# History
# -------
# 
# ???????? - ?@? - Created (various authors)
# 20100324 - ric.defrance@iag.com.au - Added vsz and rss
# 20100412 - warren page - added nice
# 20100603 - ric.de.france@iag.com.au - Fixed spaces with Alex
# yyyymmdd - who@where - Comments...
#
################################################################################

#open (FILE,'>/tmp/debugCheckPID.txt');

if ($#ARGV >= 0) {
	$pidlist = $ARGV[0];
}
else {
	use Sys::Hostname;
	$host = hostname;
	$pidlist = "/usr/local/mware/system/$host/monitorPidFiles.txt";
	#print "check $pidlist \n";
}
#print "Reading $pidlist \n";

open(PIDFILELIST,$pidlist);

while (<PIDFILELIST>) {
	chomp;
# 	@fields = split(' ', $_, 8); 
	@fields =	($_ =~ m/^\s*(\S*)\s(\S*)\s(.*\.pid)/);  # Assign the pid file to $1
	$fields[3] = $_;  # Assign the pid file to $1
	$fields[3] =~ s/.*\.pid ?//;  # Assign the pid file to $1
	$id = $fields[0];
	if (length($id) > 0) {
		$type = $fields[1];
		$file = $fields[2];

		print FILE "File is: $file \n";
		if ( -e $file ) {
			print "PidCheck|$id:exists=1\n";
			#print "exists";
			open (pidf,$file);
			$running = "RUNNING";
			$pid = <pidf>;
			chomp($pid);
			open (PIDPIPE,"ps -o 'class= comm= vsz= rss= nice=' -p $pid|");
			$cmd = <PIDPIPE>;
			print "PidCheck|$id:pid=pid$pid\n";
			#print FILE $cmd;
			if ( length($cmd) == 0) {
				print "PidCheck|$id:running=0\n";
			}
			else
			{
				print "PidCheck|$id:running=1\n";

				# Check proc is in the correct class, else reassign its class
				($ps{class}, $ps{comm}, $ps{vsz}, $ps{rss}, $ps{nice}) = split(/\s+/, $cmd, 5);   # split the fields
				chomp $ps{rss};
				print "PidCheck|$id|memory:vsz=$ps{vsz}\n";
				print "PidCheck|$id|memory:rss=$ps{rss}\n";
				print "PidCheck|$id:nice=$ps{nice}\n";

				$class = (defined $fields[3] and ($fields[3] ne '')) ? $fields[3] : $ps{class};  # if the monitorPidFiles doesn't have a class def. then match the ps output
				if ($class ne $ps{class}) {
					system("/usr/bin/logger", "-p", "user.info", "-t", "checkPidFiles.pl", "Reassigning the $id process ($pid) from class $ps{class} to $class"); 
					system("sudo", "/usr/sbin/wlmassign", "$class", "$pid"); 
				}
			}
		}
		else {
			print "PidCheck|$id:exists=0\n";
			$pid = "0";
		}
		#print "$type $id $running $pid $cmd\n";
	}
}

#close(FILE);
close(PIDFILE);
