#! perl -w
###############################################################################
#
# pingcheck.pl
#
###############################################################################
#
# A script to ping hosts
#
###############################################################################
#
# History
# -------
#
# 20100522 - Warren - Created
# yyyymmdd - who@where - Comments...
#
###############################################################################

###############################################################################
# Import modules
###############################################################################
use strict;
use Net::Ping;
use Getopt::Long;
use Time::HiRes;

my $hostname=`hostname`;
chomp($hostname);
my $hostlist_filename = '';
my $host = '';
my $result = "";


###############################################################################
# MAIN
###############################################################################
# Interrogate script arguments
###############################################################################
GetOptions (
	'file=s' => \$hostlist_filename,
);

if (( $hostlist_filename eq '' )) 
{
    #die "usage: \'$0 -file <filename>\'"; 
    $hostlist_filename = "/usr/local/mware/system/$hostname/pinghostcheck.txt";
}

###############################################################################
# Open the file and read list into array
###############################################################################
#print "Reading host list from $hostlist_filename\n";
chomp($hostlist_filename);

#$hostlist_filename='hostlist.txt';
open(DAT, $hostlist_filename) || die("Could not open file!");
my @hostlist=<DAT>;
close(DAT);



###############################################################################
# Iterate through the array and check hosts
###############################################################################
my $p = Net::Ping->new();

foreach $host (@hostlist)
{
    chomp($host);
    
    my $start_time = [ Time::HiRes::gettimeofday( ) ];
    if ( $p->ping($host) )
    {
       print "PING|$host:up=1\n";
    }
    else
    {
       print "PING|$host:up=0\n";
    }
    my $resptime = int(Time::HiRes::tv_interval( $start_time ) * 1000);

    print "PING|$host:resptime=$resptime\n";

}

$p->close();






  #
  #  Other ways to do ping - FYIO
  #
  #print "$host is alive.\n" if pingecho($host);
  #  $p = Net::Ping->new("icmp");
  #  foreach $host (@host_array)
  #  {
  #      print "$host is ";
  #      print "NOT " unless $p->ping($host, 2);
  #      print "reachable.\n";
  #      sleep(1);
  #  }
  #  $p->close();
  #  
  #  $p = Net::Ping->new("tcp", 2);
  #  while ($stop_time > time())
  #  {
  #      print "$host not reachable ", scalar(localtime()), "\n"
  #          unless $p->ping($host);
  #      sleep(300);
  #  }
  #  undef($p);
  #  
  #  # For backward compatibility
  #  print "$host is alive.\n" if pingecho($host);

