#!/bin/perl

#########################################################################3
#
#  
#
#########################################################################3
sub getPidDirs {

   open(PDFILE,$piddirfile); 

   $i=0; 
   while (<PDFILE>) { 
      chomp; 
      $pdir=$_;
      #print "$pdir \n";
      &getWASPids($pdir);
   }

}


#########################################################################3
#
#  
#
#########################################################################3
sub getWASPids {

   my($dir)=@_;
   $dlen=length($dir);
   open(WASPID_PIPE,"find $dir -name '*.pid'|"); 

   $i=0; 
   while (<WASPID_PIPE>) { 
      chomp;
      #print "$_ \n";
      $pid = `cat $_`;
      chomp($pid);
      $server = substr($_,$dlen);
      #print "$pid=$server\n";
      #$server =~ m|/([^/]*)/|;

      $server =~ m|.*\/([^\.]*)\.pid|;
      $server = $1;
      #print "$pid=$server\n";
      $serverPids{$pid} = $server;
      $i++;
   }
  
   close(WASPID_PIPE);
}

#########################################################################3
#
#
#
#########################################################################3
sub trim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}


#########################################################################3
#
# Get current ps data  use -efo to get all processes
#
#########################################################################3
sub GetPidMilisecs { 

        open FILE, "</proc/$pid/psinfo";

        if ( ! FILE ) {  
            $millisecs = 0;
            return; 
        }

        seek(FILE,132,0);
        read FILE, $buf1, (stat FILE)[7];

        @ps1 = unpack "iiii", $buf1;
        #foreach (@ps1)
        #{
        #  printf("%x %b %d\n",$_,$_,$_);
        #}

        $millisecs=$ps1[0]*1000 + int($ps1[1]/1000000);

        #$usermillisecs=$ps1[0]*1000 + int($ps1[1]/1000000);
        #$sysmillisecs=$ps1[2]*1000 + int($ps1[3]/1000000);
        #$millisecs=$usermillisecs + $sysmillisecs;
        #print "milisecs= $millisecs\n";

        #close FILE or die ("$0: Close failed: $!\n");

}


#########################################################################3
#
# Get current ps data  use -efo to get all processes
#
#########################################################################3
sub GetPsefData { 

   #print "==== getting PS data\n";
   open(PSEF_PIPE,"ps -Afo '%p %x %U %c %a'|"); 

   $i=0; 
   while (<PSEF_PIPE>) { 

      chomp; 
      #print ">>>> $_ \n";

      $psline = $_;
      @psefField      = split(' ', $_, 10); 
      $pid = trim($psefField[0]);

      if ($pid ne 'PID' and length($pid) > 0)
      {
        #($xday,$hms)     = split(/-/,$psefField[1]); 
        #if (length($hms) == 0){ $hms = $xday; $xday = 0;}
        #($xhr,$xmin,$xsec) = split(/:/,$hms); 
        #$cputime{$pid} = ($xday * 86400) + ($xhr * 3600) + ($xmin * 60) + $xsec; 


        $user = $psefField[2];
        $cmd = $psefField[3];

        if ( $userprocs{$user} )
        {
           $userprocs{$user} = $userprocs{$user}+1;
        } 
        else
        {
           $userprocs{$user}=1;
        }

        next if ( $psefField[1] eq '00:00:00' );

        next if ( $cmd eq '<init>' );
        next if ( $cmd eq '<defunct>' );

        GetPidMilisecs;

        #print "Cmd: $user $cmd $psefField[1] $millisecs\n";
        next if ( $millisecs < 1000 );

        $pids[$i]        = $pid; 
        $cputime{$pid} = $millisecs;
        #$usetime{$pid} = $usermillisecs;
        #$systime{$pid} = $sysmillisecs;

        #print "Cmd: $user $cmd $psefField[1] $millisecs\n";

        if (defined $serverPids{$pid}) {
           $pidcmd{$pid} = $serverPids{$pid};
        }
        else {
           if (defined $get_CmdString{$cmd}) {
              $get_CmdString{$cmd}->();
           }
           else {
              $pidcmd{$pid} = $cmd;
           }
        }
        $pidcmd{$pid} = $user.'|'.$pidcmd{$pid};
        #print ">>>: $pidcmd{$pid}\n";
       }

      $i++; 
   } 
   close(PSEF_PIPE); 
   #print "==== End PS data\n";
}  

sub get_java {
           if ( $psline =~ /EPAgent/ ) {
            $pidcmd{$pid} = 'Introscope_EPAGENT'
           }
           elsif ( $psline =~ /iScopeWSAdminTests/ ) {
            $pidcmd{$pid} = 'Introscope_WASMonitor'
           }
           elsif ( $psline =~ /hsql_harmony/ ) {
            $pidcmd{$pid} = 'Harmony_HSQLDB'
           }
           elsif ( $psline =~ /filetailer/ ) {
             if ( $psline =~ /gc\.props/ )
             {
                $pidcmd{$pid} = 'Introscope_GCMonitor'
             }
             else
             {
                $pidcmd{$pid} = 'Introscope_FileTailer'
             }
           }
           else
           {
            print "JAVA " ;
            print $psline ;
            print " \n";
            $pidcmd{$pid} = $cmd;
           }
}

sub get_db2sysc {
            #print "==== $psefField[3] $psefField[4]\n";
            $pidcmd{$pid} = $psefField[4] . $psefField[5];
}

sub get_DataFlowEngine {
            #print "==== $psefField[2] $psefField[3] $psefField[4]\n";
            $pidcmd{$pid} = "WMB_" . $psefField[5] . "_" . $psefField[7];
}

sub get_bip {
            $pidcmd{$pid} =  "WMB_" . $psefField[5];
}

sub wmq_fld4 {
            #print "====4 $psefField[3] $psefField[4]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[4];
}

sub wmq_fld5 {
            #print "====5 $psefField[3] $psefField[5]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[5];
}

sub wmq_fld6 {
            #print "====6 $psefField[3] $psefField[6]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[6];
}

sub wmq_fld7 {
            #print "====7 $psefField[3] $psefField[7]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[7];
}

sub wmq_fld8 {
            #print "====8 $psefField[3] $psefField[8]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[8];
}

sub wmq_fld9 {
            $pidcmd{$pid} = "WMQ_" . $psefField[9];
}

sub get_amqcrsta_nd {
            #print "====cra $psefField[3] $psefField[6]\n";
            $pidcmd{$pid} = "WMQ_" . $psefField[6];
}

sub get_amqpcsea {
            $pidcmd{$pid} =  "WMQ_" . $psefField[5];
}

sub get_amqrmppa {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqrrmfa {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzdmaa {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzfuma {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzlaa0_nd {
            #print "====laa $psefField[3] $psefField[5]\n";
            $pidcmd{$pid} =  "WMQ_" . substr($psefField[5],2);
}

sub get_runmqlsr_nd {
            
            if (  $psefField[6] eq 'TCP' ) {
                $pidcmd{$pid} =  "WMQ_" . $psefField[10];
            }
            else {
                $pidcmd{$pid} =  "WMQ_" . $psefField[7];
            }
}

sub get_amqzmgr0 {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzmuc0 {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzmur0 {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

sub get_amqzxma0_nd {
            $pidcmd{$pid} =  "WMQ_" . $psefField[6];
}

#########################################################################3
#
#  Read the data from the last PS run
#
#########################################################################3
sub GetLastPSData { 
   open(LASTPSFILE,$datafile); 

   $i=0; 
   while (<LASTPSFILE>) { 
      chomp; 
      if ($i == 0)
      {
        #print "found $_ \n";
        ($lsec,$lmin,$lhour,$lmday,$lmon,$lyear,$lwday,$lyday,$lisdst) = split(',',$_);
        #print "$lsec,$lmin,$lhour,$lmday,$lmon,$lyear,$lwday,$lyday,$lisdst\n";
      }
      else
      {
         #print "$_ \n";
         @psefField      = split(' ', $_, 8); 
         $pid = trim($psefField[0]);
         $LastPids[$i]        = $pid; 
         $LastCputime{$pid} = $psefField[1];
         #$LastUsetime{$pid} = $psefField[2];
         #$LastSystime{$pid} = $psefField[3];
      }
      $i++;
   }
   close(LASTPSFILE); 
}  

#########################################################################3
#
#
#
#########################################################################3
sub writePSData {

  open(DAT,">$datafile") || die("Cannot Open File");

  print DAT "$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst\n";
  #print "$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst\n";

  foreach $pid (@pids)
  {
     if (length($pid) > 0)
     { 
        print DAT "$pid $cputime{$pid}\n"; 
        #print DAT "$pid $cputime{$pid} $usetime{$pid} $systime{$pid}\n"; 
     }
  }
  close(DAT);

}

#-------------------------------------------------------------------------
#
#
#------------------------------------------------------------------------

%get_CmdString = (    
     'java' => \&get_java,
     'db2sysc' => \&get_db2sysc,
     'bipbroker' => \&get_bip,
     'bipservice' => \&get_bip,
     'biphttplistener' => \&get_bip,
     'DataFlowEngine' => \&get_DataFlowEngine,
     'DataFlowEngine32' => \&get_DataFlowEngine,
     'DataFlowEngine64' => \&get_DataFlowEngine,
     'amqcrsta_nd' => \&get_amqcrsta_nd,
     'amqpcsea' => \&wmq_fld5,
     'amqfcxba' => \&wmq_fld6,
     'amqrmppa' => \&wmq_fld6,
     'amqrrmfa' => \&wmq_fld6,
     'amqzdmaa' => \&wmq_fld6,
     'amqzfuma' => \&wmq_fld6,
     'amqzlaa0_nd' => \&get_amqzlaa0_nd,
     'amqzlaa0' => \&get_amqzlaa0_nd,
     'amqfqpub' => \&get_amqzlaa0_nd,
     'amqzmgr0' => \&wmq_fld6,
     'amqzmuc0' => \&wmq_fld6,
     'amqzmuf0' => \&wmq_fld6,
     'amqzmur0' => \&wmq_fld6,
     'amqzxma0_nd' => \&wmq_fld6,
     'runmqlsr_nd' => \&get_runmqlsr_nd,
     'runmqchl_nd' => \&wmq_fld8,
     'runmqchi' => \&wmq_fld6,
     'runmqbrk' => \&wmq_fld6,
     'runmqtrm' => \&wmq_fld6
);

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
#print "$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst\n";

$currSecs = ($hour * 3600) + ($min * 60) + $sec;

#$piddirfile = 'piddirs.txt';
$piddirfile = $ARGV[0];
if ( -e $piddirfile )
{
  &getPidDirs();
}

#print "----------------------\n";
#while ( my ($key, $value) = each(%serverPids) ) {
#        print "$key => $value\n";
#    }


&GetPsefData();

$datafile = $ARGV[1];
if ( -e $datafile )
{
  &GetLastPSData();
}

$expectedInterval= $ARGV[2];
if ( length($expectedInterval) == 0 )
{
  $expectedInterval = 60000
}


$lastSecs = ($lhour * 3600) + ($lmin * 60) + $lsec;
$changeSecs = ($currSecs - $lastSecs) * 1000;

#print "-------------------------------------------------\n";
#print " $changeSecs seconds  $lhour:$lmin:$lsec -> $hour:$min:$sec \n";
#print "-------------------------------------------------\n";

#print "----------------------\n";
#while ( my ($key, $value) = each(%cputime) ) {
#        print "$key => $value\n";
#    }

$totalcpu=0;

#print "================ $expectedInterval $changeSecs \n";

###########################################################
#
# For each pid calculate difference between this cpu and last cpu
#
###########################################################
foreach $pid (@pids)
{
  if (length($pid) > 0)
  { 
    $cpu = $cputime{$pid};
    $lastcpu = $LastCputime{$pid};
    #print "$pid $cpu $lastcpu \n";


    #print ";$lastcpu;\n";
    if ( length($lastcpu) > 0 )
    {
      $cmd = $pidcmd{$pid};
      #print ">$cmd<";

      if ( $cmd ne 'root|wait' ) 
      {

         $cpudiff = $cpu - $lastcpu;

         if ( $cmdcpu{$cmd} )
         {
            $cmdcpu{$cmd}= $cmdcpu{$cmd}+$cpudiff;
            $cmdprocs{$cmd}= $cmdprocs{$cmd}+1;
         } 
         else
         {
            $cmdcpu{$cmd}=$cpudiff;
            $cmdprocs{$cmd}=1;
         }
         $totalcpu = $totalcpu + $cpudiff;
      }
    }


    #$toppids{$pid} = $cpuperc;
    #$tcpudiff{$pid} = $cpudiff;
    #  $cpuperc = int(($cpudiff / $changeSecs) * 10000) / 100;
    #print ">>> $pid $cpu $lastcpu $cpudiff:$usediff:$sysdiff $cpuperc\n";
    #$tusediff{$pid} = $usediff;
    #$tsysdiff{$pid} = $sysdiff;
  }
}

##############################################################################################
#
#  Accumulate totals by Command instead of pid
#
#############################################################################################

#sub percDescending {
#   $toppids{$b} <=> $toppids{$a};
#}

#foreach $pid (sort percDescending (keys(%toppids))) {

#foreach $pid (keys(%toppids)) {
#   #print "\t\t$toppids{$pid} \t\t $pid\n";
#
#      $cmd = $pidcmd{$pid};
#      #print "Accumulating: $pid  -> $cmd\n";
#
#      $cpuperc =  $toppids{$pid};
#      $cpudiff = $tcpudiff{$pid};
#
#      #print ">> $cpudiff:$tusediff{$pid}:$tsysdiff{$pid}\n";
#
#      if ( $cmdcpu{$cmd} )
#      {
#         $cmdcpu{$cmd}= $cmdcpu{$cmd}+$cpudiff;
#         #$cmdusecpu{$cmd}= $cmdusecpu{$cmd}+ $tusediff{$pid};
#         #$cmdsyscpu{$cmd}= $cmdsyscpu{$cmd}+ $tsysdiff{$pid};
#         $cmdprocs{$cmd}= $cmdprocs{$cmd}+1;
#      } 
#      else
#      {
#         $cmdcpu{$cmd}=$cpudiff;
#         #$cmdusecpu{$cmd}= $tusediff{$pid};
#         #$cmdsyscpu{$cmd}= $tsysdiff{$pid};
#         $cmdprocs{$cmd}=1;
#      }
#
#      #print "$cpuperc $cpudiff $type:$pid $servername\n";
#      $totalcpu = $totalcpu + $cpudiff;
#
#      #if ( $cpuperc > 100 )
#      #{
#      #   #print "excessive cpu\n";
#      #   $host = `hostname`;
#      #   $email = 'warren.page@iag.com.au';
#      #   $mail = `echo "$lhour:$lmin:$lsec $hour:$min:$sec $cpuperc $cpudiff $type: $pid $servername" | mail -s"$host $cpuperc CPU $servername" $email`;
#     # }
#
#}


foreach $cmd (keys(%cmdcpu)) {

      $cpudiff = $cmdcpu{$cmd};

      #print "CPUProc\|".$cmd.":cpu=".$cpudiff."\n";
      #print "CPUProc\|".$cmd.":usecpu=".$cmdusecpu{$cmd}."\n";
      #print "CPUProc\|".$cmd.":syscpu=".$cmdsyscpu{$cmd}."\n";
      #print "CPUProc\|".$cmd.":cpupct=".$cpuperc."\n";
      #print "CPUProc\|".$cmd.":cpuprocs=".$cmdprocs{$cmd}."\n";

      print "<metric type=\"PerIntervalCounter\" name=\"CPUProcs2\|".$cmd.":cpu\" value=\"".$cpudiff."\"/>\n";
      print "<metric type=\"IntCounter\" name=\"CPUProcs2\|".$cmd.":cpuprocs\" value=\"".$cmdprocs{$cmd}."\"/>\n";

}
 
foreach $user (keys(%userprocs)) {

      print "<metric type=\"IntCounter\" name=\"CPUProcs2\|".$user.":procs\" value=\"".$userprocs{$user}."\"/>\n";

}

print "<metric type=\"PerIntervalCounter\" name=\"CPUProcs2:totalcpu\" value=\"".$totalcpu."\"/>\n";
#print "-------------------------------------------------\n";
#print ">> Total CPU= $totalcpu\n";
#print "-------------------------------------------------\n";

&writePSData();
